angular.module('ngApp').controller('FormsCtrl', function($scope, $timeout, $ionicPopup, $stateParams, ionicDatePicker, ionicTimePicker, $ionicLoading, $http, $window) {

    $scope.inappPayment = inappPaymentRequest;
    
    $scope.fileChange = function (files, field)
    {
        if (files != null)
        {
            var file = files[0];
            if (window.FileReader != null && typeof file != "undefined" && typeof file.type != "undefined")
            {
                if(file.size < 10*1024*1024){
                    $timeout(function() {
                        var fileReader = new FileReader();
                        fileReader.readAsDataURL(file); // convert the image to data url.
                        fileReader.onload = function(e) {
                            $timeout(function() {
                                $("#" + field + "_file").html(e.target.result);
                                var nameInput = $("#" + field + "_name");
                                nameInput.val(file.name);
                                nameInput.trigger('input');
                                nameInput.trigger('change');
                                if(file.type.indexOf('image') > -1){
                                    $("#" + field + "_btn").addClass('fill').removeClass('video pdf other audio').css('background-image','url('+ e.target.result +')');
                                }else if(file.type.indexOf('audio') > -1){
                                    $("#" + field + "_btn").addClass('fill audio').removeClass('video pdf other').css('background-image','none');
                                }else if(file.type.indexOf('video') > -1){
                                    $("#" + field + "_btn").addClass('fill video').removeClass('audio pdf other').css('background-image','none');
                                }else if(file.type.indexOf('pdf') > -1){
                                    $("#" + field + "_btn").addClass('fill pdf').removeClass('video audio other').css('background-image','none');
                                }else{
                                    $("#" + field + "_btn").addClass('fill other').removeClass('video pdf audio').css('background-image','none');
                                }
                            });
                        }
                    });
                }
                else{
                    $("#" + field).val('');
                    $ionicPopup.alert({
                        title: lang('forms.error'),
                        template: lang('forms.maximum_file_size'),
                        okText: lang('forms.close')
                    });
                }

            }
            else {
                $("#" + field + "_btn").removeClass('fill video pdf other audio').css('background-image','none');
                $("#" + field + "_name").val('');
                $("#" + field + "_file").val('');
                $ionicPopup.alert({
                    title: lang('forms.error'),
                    template: lang('forms.file_not_valid'),
                    okText: lang('forms.close')
                });
            }
        }
    };

    if($stateParams.search){
        document.getElementById("searchable").innerHTML = doHighlight(document.getElementById("searchable").innerHTML,$stateParams.search);
    }

    var datevalue = false, timevalue = false;
    $scope.openDatePicker = function(model, time){
      ionicDatePicker.openDatePicker({
        callback: function (unix, dateString) {
          datevalue = unix;
          $scope[model] = dateString;
          if(time) {
            ionicTimePicker.openTimePicker({
              callback: function (val) {
                timevalue = val;
                var selectedTime = typeof (val) === 'undefined' ? new Date() : new Date(val * 1000);
                $scope[model] = dateString + ' - ' + selectedTime.getUTCHours() + ':' + selectedTime.getUTCMinutes();
              },
              inputTime: timevalue != false ? timevalue : (new Date()).getHours() * 60 * 60,
            });
          }
        },
        inputDate: datevalue != false ? new Date(datevalue) : new Date(),
      });
    };
    
    $scope.openTimePicker = function(model){
        ionicTimePicker.openTimePicker({
            callback: function (val) {
                timevalue = val;
                var selectedTime = typeof (val) === 'undefined' ? new Date() : new Date(val * 1000);
                $scope[model] = selectedTime.getUTCHours() + ':' + selectedTime.getUTCMinutes();
            },
            inputTime: timevalue != false ? timevalue : (new Date()).getHours() * 60 * 60,
        });
    };

    function verifyInappPayment(result, type, sl, appUserDataId) {
        $ionicLoading.show();
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/payment/cafebazaarVerifyPayment?sl=' + sl,
            data: {
                packageName: result.packageName,
                productId: result.productId,
                purchaseToken: result.purchaseToken,
                provider: paymentPaymentProvider.providerName,
                code: result.code,
                type: type,
                appUserDataId: appUserDataId
            },
            responseType: 'json'
        })
        .success(function(data) {
            $ionicLoading.hide();
            data.success === true ?
                inappPaymentSucceeded(result)
                : showError(data.error);
        })
        .error(function() {
            $ionicLoading.hide();
            $ionicPopup.alert({
                cssClass: 'iap_pupop',
                title: '',
                template: lang('payment.fail_iap_confirm'),
                buttons: [{
                    text: '<b>تلاش مجدد</b>',
                    type: 'button-positive',
                    onTap: function() {
                        verifyInappPlanPayment(result, type, sl);
                    }
                }, {
                    text: 'بستن',
                    type: 'button-stable'
                }]
            });
        });
    };
    function inappPaymentRequest(productId, appUserDataId) {
        var type = 'buy';
        var finalResponse = {
            data: {
                success: false,
                payload: {
                    provider: paymentPaymentProvider,
                },
            },
        };
        if(!isDevice) {
            showWarning(lang('payment.not_available_in_similator'));
            finalResponse.data.error = 'This feature is only available in application';
            return finalResponse;
        }
        if(!isOnline()) {
            checkYourInternet();
            finalResponse.data.error = 'Check your internet connection';
            return finalResponse;
        }
        $ionicLoading.show();
        inappbilling.consumePurchase(function (data) {}, function () { }, productId);
        inappbilling.init(function() {
            inappbilling[type](
                function(result) {
                    verifyInappPayment(result, type, payment_sl, appUserDataId);
                }, function() {
                    $ionicLoading.hide();
                    showError(lang('payment.payment_failed'));
                    return;
                },
                productId
            );
        }, function() {
            $ionicLoading.hide();
            showWarning(
                lang('payment.fail_iap_message1') +
                paymentPaymentProvider.providerName +
                lang('payment.fail_iap_message2') 
            );
            setTimeout(function () {
                paymentPaymentProvider.providerName === 'cafebazaar' ?
                    window.open('bazaar://login', '_system') :
                    window.open('myket://details', '_system');
            }, 3000);
        },{
            showLog: false
        },
        paymentPaymentProvider.providerName === 'cafebazaar' ?
            'com.farsitel.bazaar' : 'ir.mservices.market',
        paymentPaymentProvider.providerName === 'cafebazaar' ?
            'ir.cafebazaar.pardakht.InAppBillingService.BIND' :
            'ir.mservices.market.InAppBillingService.BIND',
        paymentPaymentProvider.RSAKey);
    }
    function inappPaymentSucceeded(purchaseResult) {
        $ionicPopup.show({
            cssClass: 'iap_pupop',
            title: lang('payment.payment_successed'),
            buttons: [{
                text: lang('global.close'),
                type: 'button-clear button-balanced'
            }],
        });
        // purchaseResult.purchaseToken
        var productId = purchaseResult.productId;
        inappbilling.consumePurchase(function (data) {}, function () { }, productId);
        $window.location.hash = homeHash;
    }
});
